Middleware & request customization

25 Jul 202524 minutes to read

The Syncfusion EJ2 JavaScript DataManager supports middleware functionality, allowing you to intercept, inspect, and manipulate data requests and responses as they flow between the client and server. This feature offers a flexible way to implement cross-cutting concerns such as authentication, input validation, request logging, header customization, data transformation, and more.

Authorization handling

Authorization handling is one of the most essential and common use cases for middleware in Syncfusion EJ2 JavaScript DataManager. It ensures that your application securely communicates with protected APIs by injecting authentication credentials such as Bearer tokens, API keys, or session identifiers into outgoing HTTP requests.

Use of middleware for authorization:

Implementing authorization through middleware centralizes the logic for token management and request protection, making your codebase more secure, scalable, and maintainable. With Pre-Request middleware, you can ensure that every request to the server includes the required credentials without modifying each request manually.

Middleware types:

Middleware in DataManager can be applied at two stages:

  • Pre-Request middleware.

  • Post-Request middleware.

Pre-Request middleware

The applyPreRequestMiddlewares method enables you to intercept and customize HTTP requests before they are sent to the server. This is particularly useful for adding authorization headers (e.g., bearer token), appending custom query parameters, or modifying request payloads to meet backend expectations. It ensures secure and dynamic request configuration, especially when integrating with authenticated or complex APIs.

For example, you can programmatically inject an authentication token or enrich headers based on user context.

If you’re building a SaaS admin dashboard where users log in and fetch their own data from a secured RESTful Web APIs. Each user is issued a JWT (JSON Web Token) after authentication. Every request sent by the Syncfusion DataManager must include this token to validate the user’s identity.

By using applyPreRequestMiddlewares, you can automatically inject the JWT into the request headers as an authorization field. This avoids manual token handling and ensures every DataManager request remains authenticated.

var template = '<tr><td>${OrderID}</td><td>${CustomerID}</td><td>${EmployeeID}</td></tr>';
var compiledFunction = ej.base.compile(template);
var table = document.getElementById('datatable');

var SERVICE_URI = 'https://services.syncfusion.com/js/production/';

var dataManager = new ej.data.DataManager({
    url: SERVICE_URI + 'api/Orders',
    adaptor: new ej.data.WebApiAdaptor()
});

dataManager.applyPreRequestMiddlewares = async function (request) {
    try {
    var response = await fetch('https://jsonplaceholder.typicode.com/todos', {
        method: 'POST',
        headers: {
        'Content-Type': 'application/json'
        }
    });

    var data = await response.json();
    var token = data.id; // Simulate token value.

    return {
        headers: {
        Authorization: 'Bearer ' + token
        }
    };
    } catch (err) {
    console.error('Token fetch failed:', err);
    return {};
    }
};

dataManager.executeQuery(new ej.data.Query()).then(function (e) {
    e.result.forEach(function (data) {
    table.appendChild(compiledFunction(data)[0]);
    });
});
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-grids/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
    <style>
      .e-table {
        border: solid 1px #e0e0e0;
        border-collapse: collapse;
        font-family: Roboto;
      }

      .e-table td,
      .e-table th {
        border-style: solid;
        border-width: 1px 0 0;
        border-color: #e0e0e0;
        display: table-cell;
        font-size: 14px;
        line-height: 20px;
        overflow: hidden;
        padding: 8px 21px;
        vertical-align: middle;
        white-space: nowrap;
        width: auto;
      }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>
<body>
    <div id="container">
    <table id="datatable" class="e-table">
      <thead>
        <tr>
          <th>Order ID</th>
          <th>Customer ID</th>
          <th>Employee ID</th>
        </tr>
      </thead>
      <tbody></tbody>
    </table> 
    </div>
<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
</script>
<script src="index.js" type="text/javascript"></script>
</body></html>

In this example, the middleware intercepts the request object, adds an Authorization header, and then forwards the modified request to the server.

PreRequestMiddlewares

Post-Request middleware

The applyPostRequestMiddlewares method allows you to intercept and manipulate the response after it’s received from the server but before it’s bound to the UI component. This is ideal for transforming API response formats, filtering unnecessary fields, renaming keys, or applying custom formatting to match the structure expected by your application.

If your API returns a nested object, but your component expects a flat array. Using applyPostRequestMiddlewares, you can flatten and restructure the response seamlessly.

For example, in a sales dashboard, the API may return product data with inconsistent formats such as uppercase product names, UNIX timestamps, and field names so you can use the middleware to convert names to title case, format timestamps into readable dates, and rename keys (e.g., prod_id to ProductID) before displaying the data.

const tableBody = document.getElementById('datatable').querySelector('tbody');
if (!tableBody) throw new Error('Table body not found');

const SERVICE_URI = 'https://services.syncfusion.com/js/production/';

const dataManager = new ej.data.DataManager({
  url: SERVICE_URI + 'api/Orders',
  adaptor: new ej.data.WebApiAdaptor()
});

// Middleware stack function.
function applyMiddlewareStack(stack) {
  return async function (result) {
    let modifiedResult = result;
    for (const fn of stack) {
      modifiedResult = await fn(modifiedResult);
    }
    return modifiedResult;
  };
}

// Apply custom post-request middlewares.
dataManager.applyPostRequestMiddlewares = applyMiddlewareStack([
  async (result) => {
    console.log('Original Data:', result);

    if (!Array.isArray(result)) {
      throw new Error('Expected result to be an array');
    }

    return result.map((item) => ({
      id: item.OrderID,
      name: item.CustomerID.toLowerCase(),
      date: item.OrderDate
        ? new Date(item.OrderDate).toLocaleDateString()
        : 'N/A'
    }));
  },

  async (result) => {
    console.log('Transformed Data:', result);
    return result;
  }
]);

// Execute query and render data.
dataManager.executeQuery(new ej.data.Query()).then((e) => {
  e.result.forEach(data => {
    const tr = document.createElement('tr');

    const tdId = document.createElement('td');
    tdId.textContent = data.id.toString();
    tr.appendChild(tdId);

    const tdName = document.createElement('td');
    tdName.textContent = data.name;
    tr.appendChild(tdName);

    const tdDate = document.createElement('td');
    tdDate.textContent = data.date;
    tr.appendChild(tdDate);
    tableBody.appendChild(tr);
  });
}).catch(error => {
  console.error('❌ Data fetch error:', error);
});
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-grids/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
    <style>
      .e-table {
        border: solid 1px #e0e0e0;
        border-collapse: collapse;
        font-family: Roboto;
      }

      .e-table td,
      .e-table th {
        border-style: solid;
        border-width: 1px 0 0;
        border-color: #e0e0e0;
        display: table-cell;
        font-size: 14px;
        line-height: 20px;
        overflow: hidden;
        padding: 8px 21px;
        vertical-align: middle;
        white-space: nowrap;
        width: auto;
      }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>
<body>
    <div id="container">
    <table id="datatable" class="e-table">
      <thead>
        <tr>
          <th>Order ID</th>
          <th>Customer ID</th>
          <th>Date</th>
        </tr>
      </thead>
      <tbody></tbody>
    </table>  
    </div>
<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
</script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Original data:
PostRequestMiddlewares-before
Transformed data:
PostRequestMiddlewares-after

Supported data adaptors

Middleware functions are compatible with various DataManager adaptors, including WebApiAdaptor, ODataAdaptor, and CustomAdaptor. They support both local and remote data processing. By leveraging middleware, you can improve the flexibility, security, and efficiency of data handling within your application.

The following code example demonstrates how to use Syncfusion’s WebApiAdaptor while applying middleware logic to modify requests and responses. Before sending a request to the backend, the applyPreRequestMiddlewares method retrieves an authentication token from an external middleware server and adds it to the request headers. If the middleware server fails to return a valid token, the dataManagerFailure event is triggered to handle the error.

The applyPostRequestMiddlewares method processes the server response before updating the component. This allows for any necessary transformations, such as filtering or reformatting, to be applied before the data is bound to the UI. These middleware methods enhance request lifecycle management, improve security, and offer greater control over data manipulation in applications.

var template =
'<tr><td>${OrderID}</td><td>${CustomerID}</td><td>${EmployeeID}</td></tr>';
var compiledFunction = ej.base.compile(template);
var table = document.getElementById('datatable');

var SERVICE_URI = 'https://services.syncfusion.com/js/production/';

var dataManager = new ej.data.DataManager({
url: SERVICE_URI + 'api/Orders',
adaptor: new ej.data.WebApiAdaptor(),
});
// Method to apply middleware before sending a request to the server.
dataManager.applyPreRequestMiddlewares = async function (request) {
try {
  // Fetch authentication token from an external service.
  const response = await fetch('https://jsonplaceholder.typicode.com/todos', // Replace with your actual endpoint. This URL is just for example purposes.
  {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json',
    }
  });

  const data = await response.json();
  const token = data.id; 
  // Return the authentication token.
  return {
    headers: {
      Authorization: `Bearer ${token}`,
    },
  };
} catch (err) {
  console.error('Token fetch failed:', err);
  return {};
}
};

// Method to apply middleware after receiving a response from the server.
dataManager.applyPostRequestMiddlewares = async function (response) {
return response;
};

dataManager.dataManagerFailure = (e) => {
  // Handle DataManager failure event.
}

dataManager.executeQuery(new ej.data.Query()).then(function (e) {
  e.result.forEach(function (data) {
    table.appendChild(compiledFunction(data)[0]);
  });
});
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-grids/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
    <style>
      .e-table {
        border: solid 1px #e0e0e0;
        border-collapse: collapse;
        font-family: Roboto;
      }

      .e-table td,
      .e-table th {
        border-style: solid;
        border-width: 1px 0 0;
        border-color: #e0e0e0;
        display: table-cell;
        font-size: 14px;
        line-height: 20px;
        overflow: hidden;
        padding: 8px 21px;
        vertical-align: middle;
        white-space: nowrap;
        width: auto;
      }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>
<body>
    <div id="container">
    <table id="datatable" class="e-table">
      <thead>
        <tr>
          <th>Order ID</th>
          <th>Customer ID</th>
          <th>Employee ID</th>
        </tr>
      </thead>
      <tbody></tbody>
    </table>  
    </div>
<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
</script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Pre middlewares request response:
Pre-Middlewares-Request
Post middlewares request response:
Post-Middlewares-Request

Custom headers

The Syncfusion EJ2 JavaScript DataManager allows you to add custom HTTP headers to each request, enabling advanced scenarios such as:

  • Authentication – for example, adding a JWT token to verify the user.

  • Multi-tenant access – such as including a tenant ID to identify which tenant the request belongs to.

  • Feature control or localization – like enabling specific features or setting language preferences.

  • Content negotiation or routing – to handle different content types or direct requests based on custom logic

When making cross-origin requests with custom headers, browsers will automatically issue a preflight (options) request to verify server permissions.

Ways to add custom headers:

  • Static headers during DataManager initialization.

  • Dynamic headers via applyPreRequestMiddlewares.

  • Custom adaptor-level injection for advanced control.

Using the headers property

You can assign custom headers directly during the initialization of the DataManager by using the headers property. This approach is ideal when you have static or pre-defined headers such as authorization tokens or tenant IDs.

This method ensures that all requests made by the DataManager automatically include these headers without the need for additional logic or middleware handling. This is useful for sending static API keys, including content-type headers, applying application-level custom identifiers.

var template ='<tr><td>${OrderID}</td><td>${CustomerID}</td><td>${EmployeeID}</td></tr>';

var compiledFunction = ej.base.compile(template);

const SERVICE_URI = 'https://services.syncfusion.com/js/production/api/Orders';

var table = document.getElementById('datatable');
new ej.data.DataManager({
  url: SERVICE_URI,
  adaptor: new ej.data.ODataV4Adaptor(),
  headers: [{ syncfusion: 'true' }],
})
  .executeQuery(new ej.data.Query())
  .then((e) => {
    e.result.forEach((data) => {
      table.appendChild(compiledFunction(data)[0]);
    });
  });
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-grids/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
    <style>
      .e-table {
        border: solid 1px #e0e0e0;
        border-collapse: collapse;
        font-family: Roboto;
      }

      .e-table td,
      .e-table th {
        border-style: solid;
        border-width: 1px 0 0;
        border-color: #e0e0e0;
        display: table-cell;
        font-size: 14px;
        line-height: 20px;
        overflow: hidden;
        padding: 8px 21px;
        vertical-align: middle;
        white-space: nowrap;
        width: auto;
      }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>
<body>
    <div id="container">
    <table id="datatable" border="1" class="e-table">
      <thead>
        <tr>
          <th>Order ID</th>
          <th>Customer ID</th>
          <th>Employee ID</th>
        </tr>
      </thead>
      <tbody></tbody>
    </table> 
    </div>
<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
</script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Custom-header

Using beforeSend

The beforeSend callback allows you to dynamically modify request headers just before the request is dispatched. This is useful when headers depend on runtime information, such as freshly fetched tokens or user specific data.

Parameters:

It accepts an three arguments:

  • DataManager (dm): Provides the datasource and adaptor value.

  • Request (request): Used to send custom headers, such as setting the Authorization header.

  • Settings (settings): An optional argument that allows additional configurations.

var template =
  '<tr><td>${OrderID}</td><td>${CustomerID}</td><td>${EmployeeID}</td></tr>';

var compiledFunction = ej.base.compile(template);

const SERVICE_URI = 'https://services.syncfusion.com/js/production/api/Orders';

var table = document.getElementById('datatable');

class CustomODataAdaptor extends ej.data.ODataV4Adaptor {
  beforeSend(dm, request, settings) {
    // You can modify headers, URL, or method here.
    request.headers.set('syncfusion', 'true');
    super.beforeSend(dm, request, settings);
  }
}
new ej.data.DataManager({
  url: SERVICE_URI,
  adaptor: new CustomODataAdaptor(),
})
  .executeQuery(new ej.data.Query())
  .then((e) => {
    e.result.forEach((data) => {
      table.appendChild(compiledFunction(data)[0]);
    });
  });
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-grids/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
    <style>
      .e-table {
        border: solid 1px #e0e0e0;
        border-collapse: collapse;
        font-family: Roboto;
      }

      .e-table td,
      .e-table th {
        border-style: solid;
        border-width: 1px 0 0;
        border-color: #e0e0e0;
        display: table-cell;
        font-size: 14px;
        line-height: 20px;
        overflow: hidden;
        padding: 8px 21px;
        vertical-align: middle;
        white-space: nowrap;
        width: auto;
      }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>
<body>
    <div id="container">
    <table id="datatable" border="1" class="e-table">
      <thead>
        <tr>
          <th>Order ID</th>
          <th>Customer ID</th>
          <th>Employee ID</th>
        </tr>
      </thead>
      <tbody></tbody>
    </table> 
    </div>
<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
</script>
<script src="index.js" type="text/javascript"></script>
</body></html>

custom-header-beforeSend

Sending additional parameters to server

When working with remote data sources, it is often necessary to send additional parameters to the server, such as filtering values, paging limits, or culture settings. The DataManager supports this by allowing custom parameters to be appended to the query string of the request using the addParams method.

The addParams method of the Query class is used to append custom query string parameters to the request sent by the DataManager. These parameters are useful when you want to pass additional data required by the server to process the request.

The following example demonstrates how to send an additional parameter ($top) to limit the number of records retrieved from the server:

var template =
  '<tr><td>${OrderID}</td><td>${CustomerID}</td><td>${EmployeeID}</td></tr>';

var compiledFunction = ej.base.compile(template);

const SERVICE_URI =
  'https://services.odata.org/V4/Northwind/Northwind.svc/Orders';

var table = document.getElementById('datatable');

new ej.data.DataManager({
  url: SERVICE_URI,
  adaptor: new ej.data.ODataV4Adaptor(),
})
  .executeQuery(new ej.data.Query().addParams('$top', '7'))
  .then((e) => {
    e.result.forEach((data) => {
      table.appendChild(compiledFunction(data)[0]);
    });
  });
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-grids/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
    <style>
      .e-table {
        border: solid 1px #e0e0e0;
        border-collapse: collapse;
        font-family: Roboto;
      }

      .e-table td,
      .e-table th {
        border-style: solid;
        border-width: 1px 0 0;
        border-color: #e0e0e0;
        display: table-cell;
        font-size: 14px;
        line-height: 20px;
        overflow: hidden;
        padding: 8px 21px;
        vertical-align: middle;
        white-space: nowrap;
        width: auto;
      }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>
<body>
    <div id="container">
    <table id="datatable" border="1" class="e-table">
      <thead>
        <tr>
          <th>Order ID</th>
          <th>Customer ID</th>
          <th>Employee ID</th>
        </tr>
      </thead>
      <tbody></tbody>
    </table> 
    </div>
<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
</script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Additional-parameter

Applying Middleware logic in Vue Data control

25 Apr 20256 minutes to read

The Syncfusion® DataManager allows you to implement middleware logic in your application. It enables you to modify requests and responses before they are sent to the server or processed by the client. This is useful for tasks such as authentication, validation, logging, and response transformation. You can apply middleware using two methods: applyPreRequestMiddlewares and applyPostRequestMiddlewares. The following sections provide a detailed explanation of these methods.

Pre-Request Middleware

The applyPreRequestMiddlewares method runs before a request is sent to the back end. It allows you to modify request headers, query parameters, or payloads. This is commonly used for adding authentication tokens, restructuring requests, or validating data before it is sent. The following code snippet demonstrates how to add an authorization token:

dataManager.applyPreRequestMiddlewares([
    async (context) => {
      context.request.headers['Authorization'] = 'Bearer your-access-token';
    }
]);

Post-Request Middleware

The applyPostRequestMiddlewares method runs after a response is received from the server but before binding the data to a component. It allows you to modify, filter, or restructure response data as needed. The following code snippet demonstrates how to format response data:

dataManager.applyPostRequestMiddlewares([
    async (context) => {
        context.response.result = context.response.result.map(item => ({
            id: item.Id,
            name: item.Name.toUpperCase(),
            date: new Date(item.Timestamp).toLocaleDateString()
        }));
    }
]);

Supported Data Adaptors

Middleware functions work with various DataManager adaptors, including WebApiAdaptor, ODataAdaptor, and CustomAdaptor. They can be used for both local and remote data processing. By using middleware, you can enhance the flexibility, security, and efficiency of data handling in your applications.

The following code example demonstrates how to use Syncfusion’s® UrlAdaptor while applying middleware logic to modify requests and responses. Before sending a request to the back end, the applyPreRequestMiddlewares method retrieves an authentication token from an external middleware server and adds it to the request headers. If the middleware server fails to return a valid token, the DataManager failure event is triggered to handle the error.

Similarly, the applyPostRequestMiddlewares method processes the response before updating the component. This ensures that any necessary modifications, such as data transformation or filtering, are applied before binding the response to the UI. These middleware methods enhance request handling, improve security, and provide better control over data processing in the applications.

<template>
  <div id="app">
    <table class='e-table'>
      <tr><th>Order ID</th><th>Customer ID</th><th>Employee ID</th><th>Ship Country</th></tr>
      <tr v-for="(item, index) in items" :key="index">
        <td>{{ item.OrderID }}</td>
        <td>{{ item.CustomerID }}</td>
        <td>{{ item.EmployeeID }}</td>
        <td>{{ item.ShipCountry }}</td>
      </tr>
    </table>   
  </div>
</template>

<script>
import { DataManager, Query, UrlAdaptor} from '@syncfusion/ej2-data';

export default {
  data() {
    return {
      items: [] 
    };
  },
  mounted() {
    let SERVICE_URI = "https://services.syncfusion.com/vue/production/api/UrlDataSource";
    let dataManager = new DataManager({
      url: SERVICE_URI,
      adaptor: new UrlAdaptor()
    }).executeQuery(new Query().take(12)).then((e) => {
      this.items = e.result;
    });

      // Method to apply middleware before sending a request to the server.
      dataManager.applyPreRequestMiddlewares = async (request) => {
        const response = await fetch("https://example.com/api/token", { // Replace with your actual endpoint. This URL is just for example purposes.
          method: "POST",
          headers: {
            "Content-Type": "application/json",
          },
        });
        if (!response.ok) {
            throw new Error(`HTTP error! Status: ${response.status}`);
        }
        return { token: "your_token_value" };
      };
  
      dataManager.dataManagerFailure = (e) => {
        //Handle DataManager failure event.
      };

    // Method to apply middleware after receiving a response from the server
    dataManager.executeQuery(new Query().take(8)).then((e) => {
      this.setState({ items: e.result });
    });
  }
}
</script>
<style>
  .e-table {
    border: solid 1px #e0e0e0;
    border-collapse: collapse;
    font-family: Roboto;
  }

  .e-table td, .e-table th {
    border-style: solid;
    border-width: 1px 0 0;
    border-color: #e0e0e0;
    display: table-cell;
    font-size: 14px;
    line-height: 20px;
    overflow: hidden;
    padding: 8px 21px;
    vertical-align: middle;
    white-space: nowrap;
    width: auto;
  }
</style>

Applying Middleware logic in Angular Data control

20 Mar 20257 minutes to read

The Syncfusion DataManager allows you to implement middleware logic in your application. It enables you to modify requests and responses before they are sent to the server or processed by the client. This is useful for tasks such as authentication, validation, logging, and response transformation. You can apply middleware using two methods: applyPreRequestMiddlewares and applyPostRequestMiddlewares. The following sections provide a detailed explanation of these methods.

Pre-Request Middleware

The applyPreRequestMiddlewares method runs before a request is sent to the backend. It allows you to modify request headers, query parameters, or payloads. This is commonly used for adding authentication tokens, restructuring requests, or validating data before it is sent. The following code snippet demonstrates how to add an authorization token:

this.dataManager.applyPreRequestMiddlewares([
    async (context) => {
      context.request.headers['Authorization'] = 'Bearer your-access-token';
    }
]);

Post-Request Middleware

The applyPostRequestMiddlewares method runs after a response is received from the server but before binding the data to a component. It allows you to modify, filter, or restructure response data as needed. The following code snippet demonstrates how to format response data:

this.dataManager.applyPostRequestMiddlewares([
    async (context) => {
        context.response.result = context.response.result.map(item => ({
            id: item.Id,
            name: item.Name.toUpperCase(),
            date: new Date(item.Timestamp).toLocaleDateString()
        }));
    }
]);

Supported Data Adaptors

Middleware functions work with various DataManager adaptors, including WebApiAdaptor, ODataAdaptor, and CustomAdaptor. They can be used for both local and remote data processing. By using middleware, you can enhance the flexibility, security, and efficiency of data handling in your applications.

The following code example demonstrates how to use Syncfusion’s UrlAdaptor while applying middleware logic to modify requests and responses. Before sending a request to the backend, the applyPreRequestMiddlewares method retrieves an authentication token from an external middleware server and adds it to the request headers. If the middleware server fails to return a valid token, the DataManager failure event is triggered to handle the error.

Similarly, the applyPostRequestMiddlewares method processes the response before updating the component. This ensures that any necessary modifications, such as data transformation or filtering, are applied before binding the response to the UI. These middleware methods enhance request handling, improve security, and provide better control over data processing in the applications.

import { Component, OnInit } from '@angular/core';
import { DataManager, Query, UrlAdaptor } from '@syncfusion/ej2-data';
import { CommonModule } from '@angular/common';

@Component({
    imports: [CommonModule],
    standalone: true,
    selector: 'app-root',
    templateUrl: './app.template.html',
    styles: [`
            .e-table {
                border: solid 1px #e0e0e0;
                border-collapse: collapse;
                font-family: Roboto;
            }

            .e-table td, .e-table th {
                border-style: solid;
                border-width: 1px 0 0;
                border-color: #e0e0e0;
                display: table-cell;
                font-size: 14px;
                line-height: 20px;
                overflow: hidden;
                padding: 8px 21px;
                vertical-align: middle;
                white-space: nowrap;
                width: auto;
            }
    `]
})
export class AppComponent implements OnInit {
    public items: any[] = [];

    public ngOnInit(): void {
        const dataManager = new DataManager({
            url: 'https://services.syncfusion.com/js/production/api/UrlDataSource',
            adaptor: new UrlAdaptor(),
        }).executeQuery(new Query().take(8))
            .then((e: any) => {
                this.items = e.result;
            });

        // Method to apply middleware before sending a request to the server.
        dataManager.applyPreRequestMiddlewares = async (request: string | Object): Promise<object> => {
            const response = await fetch('https://example.com/api/token', { // Replace with your actual endpoint. This URL is just for example purposes.
                method: 'POST',
                headers: { 'Content-Type': 'application/json' }
            });

            if (!response.ok) {
                throw new Error(`HTTP error! Status: ${response.status}`);
            }
            return { token: "your_token_value" };
        };

        dataManager.dataManagerFailure = (e: Error) => {
            //Handle DataManager failure event.
        }

        // Method to apply middleware after receiving a response from the server
        dataManager.applyPostRequestMiddlewares = async (response: string | Object): Promise<object> => {
            return response;
        };
    }
}
<table class='e-table'>
    <tr><th>Order ID</th><th>Customer ID</th><th>Employee ID</th></tr>
    <tr *ngFor="let item of items">
        <td>{{item.OrderID}}</td><td>{{item.CustomerID}}</td><td>{{item.EmployeeID}}</td>
    </tr>
</table>

Syncfusion AI Assistant

How can I help you?

Applying Middleware logic in React DataManager

15 Apr 202610 minutes to read

The Syncfusion® DataManager supports applying middleware logic to modify requests and responses during data processing. This capability is useful for handling tasks such as authentication, validation, logging, and transforming response data. Middleware can be applied through two methods: applyPreRequestMiddlewares and applyPostRequestMiddlewares, each serving a specific stage in the data handling workflow.

Pre-Request Middleware

The applyPreRequestMiddlewares method executes before a request is sent to the server. It enables modification of request headers, query parameters, or payloads. This is commonly used for adding authentication tokens, restructuring requests, or performing validations. The following code snippet demonstrates how to add an authorization token:

dataManager.applyPreRequestMiddlewares([
  async (context) => {
    context.request.headers['Authorization'] = 'Bearer your-access-token';
  }
]);

Post-Request Middleware

The applyPostRequestMiddlewares method runs after a response is received from the server but before the data is bound to a component. It allows filtering, formatting, or restructuring the response to meet application requirements. The following code snippet demonstrates how to format response data:

dataManager.applyPostRequestMiddlewares([
  async (context) => {
    context.response.result = context.response.result.map(item => ({
      id: item.Id,
      name: item.Name.toUpperCase(),
      date: new Date(item.Timestamp).toLocaleDateString()
    }));
  }
]);

Supported data adaptors

Middleware functions are supported across multiple DataManager adaptors, including the WebApiAdaptor, ODataAdaptor, and CustomAdaptor, and can be applied to both local and remote data operations. This enhances flexibility, security, and overall control of data processing.

The example demonstrates using the UrlAdaptor with middleware to adjust requests and responses. Before sending a request, applyPreRequestMiddlewares fetches an authentication token from an external server and adds it to the request headers. If the token retrieval fails, the DataManager failure event handles the error. Likewise, applyPostRequestMiddlewares processes the server response before it is bound to the UI, enabling any required transformations or filtering.

import React, { useEffect, useState } from 'react';
import { DataManager, Query, UrlAdaptor } from '@syncfusion/ej2-data';

const App = () => {
  const [items, setItems] = useState([]);

  useEffect(() => {
    const dataManager = new DataManager({
      url: 'https://services.syncfusion.com/react/production/api/UrlDataSource',
      adaptor: new UrlAdaptor(),
    });

    // Method to apply middleware before sending a request to the server.
    dataManager.applyPreRequestMiddlewares = async (request) => {
      const response = await fetch('https://example.com/api/token', { // Replace with your actual endpoint. This URL is just for example purposes.
        method: 'POST',
        headers: {
          'Content-Type': 'application/json',
        },
      });
      if (!response.ok) {
        throw new Error(`HTTP error! Status: ${response.status}`);
      }
      return { token: 'your_token_value' };
    };

    // DataManager failure handler event.
    dataManager.dataManagerFailure = (e) => {
      console.error('DataManager error:', e);
    };

    // Method to apply middleware after receiving a response from the server.
    dataManager.applyPostRequestMiddlewares = async (response) => {
      return response;
    };

    dataManager.executeQuery(new Query().take(8)).then((e) => {
      setItems(e.result);
    });
  }, []);

  return (
    <table id="datatable" className="e-table">
      <thead>
        <tr>
          <th>Employee ID</th>
          <th>Employees</th>
          <th>Designation</th>
        </tr>
      </thead>
      <tbody>
        {items.map((row, index) => (
          <tr key={index}>
            <td>{row.EmployeeID}</td>
            <td>{row.Employees}</td>
            <td>{row.Designation}</td>
          </tr>
        ))}
      </tbody>
    </table>
  );
};

export default App;
import * as React from 'react';
import { useEffect, useState } from 'react';
import { DataManager, Query, UrlAdaptor } from '@syncfusion/ej2-data';

interface Order {
  OrderID: number;
  CustomerID?: string;
  EmployeeID?: number;
  [key: string]: any;
}

const App: React.FC = () => {
  const [items, setItems] = useState<Order[]>([]);

  useEffect(() => {
    const dataManager: DataManager = new DataManager({
      url: 'https://services.syncfusion.com/react/production/api/UrlDataSource',
      adaptor: new UrlAdaptor(),
    });

    // Method to apply middleware before sending a request to the server.
    dataManager.applyPreRequestMiddlewares = async (
      request: string | Object
    ): Promise<object> => {
      // Fetch authentication token from an external service.
      const response = await fetch('https://example.com/api/token', { // Replace with your actual endpoint. This URL is just for example purposes.
        method: 'POST',
        headers: {
          'Content-Type': 'application/json',
        },
      });

      if (!response.ok) {
       throw new Error(`HTTP error! Status: ${response.status}`);
      }
      // Return the authentication token.
      return { token: 'your_token_value' };
    };

    // Handle DataManager failure event.
    dataManager.dataManagerFailure = (e: Error) => {
      console.error('DataManager error:', e);
    };

    // Method to apply middleware after receiving a response from the server.
    dataManager.applyPostRequestMiddlewares = async (
      response: string | Object
    ): Promise<Object> => {
      return response;
    };

    dataManager.executeQuery(new Query().take(8)).then((e: any) => {
      setItems(e.result);
    });
  }, []);

  return (
    <table id="datatable" className="e-table">
      <thead>
        <tr>
          <th>Employee ID</th>
          <th>Employees</th>
          <th>Designation</th>
        </tr>
      </thead>
      <tbody>
        {items.map((row, index) => (
          <tr key={index}>
            <td>{row.EmployeeID}</td>
            <td>{row.Employees}</td>
            <td>{row.Designation}</td>
          </tr>
        ))}
      </tbody>
    </table>
  );
};

export default App;